# -*- coding: utf-8 -*-

#LEIA
#
#PARAMETROS DE ENTRADA:
#DIRETORIO TREINO - diretorio contendo os arquivos .txt para treino
#DIRETORIO TESTE - diretorio contendo os arquivos .txt para teste (em caso de cross validation deve ser o mesmo que o de treino)
#DIRETORIO DE TRABALHO - diretorio onde ficarão salvas as saídas do sistema
#DIRETORIO DO MALLET - diretorio apontando para a biblioteca MALLET
#CLASSIFICAR TODAS AS EN - se deseja que todas as EN tenham uma classificação (true ou false)
#CROSS VALIDATION - se deseja utilizar a técnica de cross validation (true ou false)
#DIREOTORIO DO MODELO - diretorio apontando para o modelo utilizado, caso o arquivo não exista será criado um novo, caso exista será utilizado o que já está salvo
#QUANTIDADE DE FOLDS - quantidade de folds da técnica de cross validation (número inteiro)
#CATEGORIAS A CLASSIFICAR... - todas as categorias que queira que o sistema reconheça separadas por espaços (não preencher para utilizar todas)
#
#USO:
#<interpretador_python_alternativo> ./NERcrf.py DIRETORIO_TREINO DIRETORIO_TESTE DIRETORIO_DE_TRABALHO DIRETORIO_MALLET DIRETORIO_MALLET CLASSIFICAR_TODAS_AS_EN CROSS_VALIDATION DIRETORIO_MODELO QUANTIDADE_DE_FOLDS <CATEGORIAS...>
#<opcional>#

import nltk.tokenize.api
import nltk.tokenize
import math
import re
import os
import pickle
import sys
import time
import os.path
import sys
import os.path
from CRFnltkNulas import CRFTrain #importa de uma determinada classe, biblioteca uma função especifica.
from CRFnltkNulas import CRF_prediction
from CRFnltkNulas import configMallet
from threading import Thread
from KNNUtil import classe
from os import mkdir

#classe utilizada para o multi-threading para as iterações do cross-validation
class Th(Thread):
    #INICIALIZAÇÃO DAS VARIÁVEIS
    labelled = []
    test = []
    iteracao = 0
    result = []
    resulCateg = []
    resulCategEN = []
    contBilou = 0
    #RECOLHE OS DADOS INICIAIS PARA O SISTEMA
    #labelled - conjunto de treino
    #teste - conjunto de teste
    #iteracao - número da iteração atual
    def __init__ (self,labelled, test, iteracao):#método construtor da classe Th, cujo objetivo é obter os dados iniciais que foram passados para esse método construtor e salvá-los em atributos da classe Th.
        sys.stdout.write("incializada thread da fold " + str(iteracao) + "\n")#impressão na tela especial para multi-threading
        sys.stdout.flush()
        Thread.__init__(self)
        #INICIALIZA OS ATRIBUTOS DA CLASSE
        self.labelled = labelled # o 'self' é usado para referenciar atributos da própria classe.
        self.test = test
        self.iteracao = iteracao

    #RODA O TREINO E TESTE DO CRF
    def run(self): # função chamada 'run' 
        bb=ii=ll=uu=0
        #tabela de confusão do BILOU
        self.result = [[0, 0], [0, 0]]
        #tabela de confusao de categorias a nivel de palavras
        self.resulCateg = []
        #tabela de confusao de categorias a nivel de EN
        self.resulCategEN = []
        #inicializa as tabelas de categorias com o tamanho especificado pelas categorias selecionadas
        for y in range(len(categoriasUsadas)):
            self.resulCateg.append([0 for b in range(len(categoriasUsadas))])
            self.resulCategEN.append([0 for b in range(len(categoriasUsadas))]) #adiciona uma linha de zeros para a matriz no primeiro momento.
#O ARQUIVO TXT É PASSADO COMO ENTRADA AO NERP-CRF. ESTE ARQUIVO JÁ ESTÁ COM POS, FORMATAÇÃO DO HAREM, E DIVIDIDO EM SENTENÇAS.
        #variável lab representa apenas valores válidos de labels, ou seja, valores válidos de um vetor com a estrutura: (('palavra','POS'),'BILOU-CATEG')
        lab = [] #inicializa a variável lab. Este laço serve para pegar somente valores válidos que possuem o formato (('palavra','POS'),'BILOU-CATEG')
        for label in self.labelled: # itera sobre os textos, ou seja, formado a variável com valores não vazios. Para o label percorrendo a lista elf.labelled que é a lista de treino que foi passada para o sistema.
            if label == None: # se o item da lista, no caso o texto estiver vazio, irá percorrer o próximo laço do for.
                continue # o continue significa que vai para o próximo laço, o próximo texto.
            if label != []:#laço sobre as palavras da sentença
                for s in label[1]:#itera sobre as sentenças de cada texto. O 1 é o texto em si. Vai pegar o vetor no formato (('palavra','POS'),'BILOU-CATEG')
                    if(s != []):
                        lab.append(s) # adiciona a sentença no vetor atual. s - (('palavra','POS'),'BILOU-CATEG')

        diretorioModeloAtual = diretorioModelo
        modeloTreino = 'NERP/NERP_CRF/./modelos/mallet_'+str(self.iteracao)
        if crossValidation:
            diretorioModeloAtual = diretorioModelo+'_'+str(self.iteracao)
        if not os.path.exists(modeloTreino):
	    print 'Modelo não encontrado, criando novo modelo\t', modeloTreino
            crf = CRFTrain(lab, diretorioTrabalho, self.iteracao, True)
            pickle.dump(crf,open(modeloTreino,'w'))
        else:
	    print 'Modelo encontrado:\t', modeloTreino, '\tUtilizando modelo já existente'
            crf = pickle.load(open(modeloTreino,'r'))

        #variável para conter os resultados do CRF
        labels = []
    
        #caminho do arquivo para salvar em formato de Tabela
        dirExc = diretorioTrabalho+'/result_' + str(self.iteracao) + 'it.ods'
    
        #limpa arquivo
        #fileEx = open(dirExc,'w') # w é modo de escrita.
        #fileEx.write('') #não escreve nada no arquivo.
        #fileEx.close()
    
        #contador de itens BILOU da iteração
        self.contBilou = 0
        
        for texto in self.test: # itera sobre o conjunto de teste, ou seja, percorre os textos de teste.
            #se estiver vazio, segue para a proxima iteração do laço
            if texto == None:
                continue
            if texto != []: # texto diferente de vazio.
                saida = open(diretorioTrabalho+'/saidaHarem'+str(self.iteracao)+'.xml', 'a')#abre o arquivo saidaHarem correspondente à thread atual
                saida.write('<DOC DOCID="' + str(texto[0])[:-4] + '">\n') #escreve no arquivo saidaHarem correspondente à thread atual o cabeçalho que estão nos textos do HAREM, para depois poder rodar no SAHARA.
                saida.close()
                file = open(diretorioTrabalho+'/marcados/' + str(texto[0]),'w')#limpa o arquivo do texto marcado que tem o seguinte formato: resultado<n,O-OUT> deverá<v-fin,O-OUT> contribuir<v-inf,O-OUT>. Isso foi feito para ver se havia erros no código.
                file.write('') # escreve vazio no arquivo para zerar o arquivo, caso ele estivesse no mesmo diretório.
                file.close()
                for s in texto[1]:#percorre as sentenças dos textos de teste

                    #inicializa vetor da marcação correta do BILOU e da categoria da CD.
                    truth = []
                    #inicializa vetor das informações de cada palavra, ou seja: 'palavra','POS'.
                    tagged = []
                    if(s != []):#verifica se a sentença não está vazia
                        #itera sobre as palavras da sentença
                        for w in s: #percorre as palavras da sentença para separar o BILOU e a categoria das palavras do seu POS e a sua palavra.
                            tagged.append(w[0]) # w[0] significa ('palavra','POS')
                            truth.append({'bilou':w[1].split('-')[0],'categ':w[1].split('-')[1]}) # w[1] significa 'BILOU-CATEG'. O split divide uma string num caracter
    
                        #usa o CRF para determinar o valor BILOU da sentença
                        labelsAux = CRF_prediction(crf, tagged) # CRF_prediction é função com o objetivo de executar o modelo CRF. 'crf' é o modelo CRF. O tagged é o conj de teste sem o BILOU e as categorias. A função CRF_prediction está no arquivo CRFnltkNulas.py. O vetor labelsAux guarda a classificação da palavra e o BILOU dela. AQUI É A SAÍDA DO SISTEMA.
                        
                        contLabels = 0 # contador de labels para fazer o alinhamento do vetor labesAux com o vetor truth.
                        
                        #escreve o vetor BILOU resultante para debugging, ou seja, escreve uma das saídas do sistema.
                        salvar = open(diretorioTrabalho+'/vetor_bilou.txt','a')
                        salvar.write(str(labelsAux)+'\n')
                        salvar.close()
                        labels = []#saída do CRF formatada
                        for l in labelsAux:#percorre a saída do CRF
                            labels.append({'bilou':l.split('-')[0],'categ':l.split('-')[1]})# converte a saída para o seguinte formato: [{'bilou':'B','categ':'PESSOA'},{'bilou':'I','categ':'PESSOA'}...]
                        if(crossValidation): # se usar cross-validation
                            dir = diretorioTrabalho+'/marcados/iteracao ' + str(self.iteracao) + '/' + str(texto[0])#caminho para a escrita do texto marcado. Procura no diretório marcados o diretório correspondente a iteração atual, para salvar o arquivo que contém o formato: resultado<n,O-OUT> deverá<v-fin,O-OUT> contribuir<v-inf,O-OUT>
                        else: # se não usar cross-validation.
                            dir = diretorioTrabalho+'/marcados/' + str(texto[0])#caminho para a escrita do texto marcado
                        #fileEx = open(dirExc,'a')#coloca o título do texto no arquivo excell
                        #fileEx.write(str(texto[0]) +'\n\n\n')
                        #fileEx.close()
                        print 'gravando em', dir, '...'
                        
                        file = open(dir,'a')  #.........................
                        file.write('\n\t')  #...............
                        file.close() #.....................
                        
                        for w in s:  # percorre as palavras da sentença para fazer as métrias, escrever as tabelas nos arquivos. O w é a palavra como o POS e o BILOU dela.   O s são as sentenças do texto.
                            file = open(dir,'a') # abre o arquivo em branco.
			    if(labels[contLabels]['bilou'] == 'B' or labels[contLabels]['bilou'] == 'L' or labels[contLabels]['bilou'] == 'U'):
				
				file.write(str(w[0][0]) + '<' + str(w[0][1]) + ',' + 'I' +'-'+ labels[contLabels]['categ'] + '> ')#no txt escreve I para BILU (pois cada palavara,a te mesmo EM composta sao marcadas separadamente (palavra por palavra)
			    else:
                            	file.write(str(w[0][0]) + '<' + str(w[0][1]) + ',' + labels[contLabels]['bilou'] +'-'+ labels[contLabels]['categ'] + '> ') # escreve a palavra, seguida pela marcaçao POS, a marcação BILOU e a categoria.
                            file.close()

                            #verifica se a palavra é início de uma entidade antes de escrevê-la no arquivo porque a marcação de começo de entidade tem que vir antes da palavra, por ex., <EM CATEG="OBRA"> Lei 9795/99 </EM>
                            if(iniEnt(labels, contLabels)): # initEnt é uma função que é chamada aqui e está mais para baixo no código.  O labels é lista no formato de dicionário e contLabels é o índice da palavra atual.
                                #inicia a tag da entidade no .xml  A tag é a estrutura abaixo.
                                saida = open(diretorioTrabalho+'/saidaHarem'+str(self.iteracao)+'.xml', 'a') # a é o modo de adicionar conteúdo no arquivo.
                                saida.write('<EM ID=\"' + str(texto[0])[:-4] + '\"') #escreve no arquivo que foi aberto na linha anterior: '<EM ID=
                                if(defineCateg(labels, contLabels) != 'OUT'): # função defineCateg que tem a função de verificar se a classificação de uma EN composta está correta. Essa linha significa que se defineCateg não for OUT, ou a seja a EN recebeu alguma classificação válida.  labels é o vetor de BILOU e classificação gerado pela execução do CRF. 
                                    saida.write(' CATEG=\"' + str(labels[contLabels]['categ']) + '\"') # escreve a categoria se ela for válida.
                                saida.write('>')
                                saida.close()
                        
                                # Aqui é formada a matriz de confusão das categorias a nivel de EN para cada fold. Posteriormente serão somadas as 5 folds.  Aqui ocorre a comparação da categoria a nível de EN. Comparando o resultado obtido pelo CRF com a coleção Dourada. 
                                self.resulCategEN[categoriasUsadas.index(truth[contLabels]['categ'])][categoriasUsadas.index(defineCateg(labels,contLabels))] += 1  # resulCategEN é uma matriz de confusão das categorias a nivel de EN.  categoriasUsadas.index(truth[contLabels]['categ']) corresponde a linha da matriz de confusão  e   [categoriasUsadas.index(defineCateg(labels,contLabels))] é a coluna da matriz.  truth é um vetor correspondendo a CD.   += 1  significa incrementa 1, ou seja, coloca mais um valor na matriz.   Aqui incrementa 1 para todas as EN encontradas.

                            #escreve a palavra no .xml
                            saida = open(diretorioTrabalho+'/saidaHarem'+str(self.iteracao)+'.xml', 'a') # é aberto o arquivo saidaHarem para escrever todas palavras do texto e um espaço em branco sem ainda a marcação de EN.
                            saida.write(str(w[0][0]) + ' ')  # escreve a palavra e o espaço em branco entre elas.  w é uma variável que indica a palavra. A posição  [0][0] me dá somente a palavra.   ' ' é o espaço em branco entre as palavras.
                            saida.close()
                            if(labels[contLabels]['bilou'] == 'B' or labels[contLabels]['bilou'] == 'I' or labels[contLabels]['bilou'] == 'L' or labels[contLabels]['bilou'] == 'U'):
                                if(labels[contLabels]['bilou'] == 'B'):
                                    bb+=1
                                elif(labels[contLabels]['bilou'] == 'I'):
                                    ii+=1
                                elif(labels[contLabels]['bilou'] == 'L'):
                                    ll+=1
                                elif(labels[contLabels]['bilou'] == 'U'):
                                    uu+=1
#arrumar aqui vou ter B I L U, considerar U como uma EM, e BIL como uma unica tb
                            #soma a tabela de confusão do BILOU a nivel de palavra.
                            #if(labels[contLabels]['bilou'] == 'B' or labels[contLabels]['bilou'] == 'U'):#arrumar aqui, pois U e B n existem
                            self.result[classe(truth[contLabels]['bilou'])][classe(labels[contLabels]['bilou'])] += 1  # classe é uma função que está no arquivo KNNUtil.py que tem o objetivo de retornar um número de acordo com o número dado para cada item do BILOU. result é a matriz de confusão do BILOU;    [classe(truth[contLabels]['bilou'])] significa que vou pegar o índice do BILOU da posição contLabels do vetor truth.  
#classe(labels[contLabels]['bilou']) significa que vou pegar o índice do BILOU da posição contLabels do vetor labels que é o vetor que contém o BILOU e a categoria da palavra.  
                            #soma a tabela de confusão de categorização a nivel de palavras
                            #elif(labels[contLabels]['bilou'] == 'O'):
                                #self.result[classe(truth[contLabels]['bilou'])][classe(labels[contLabels]['bilou'])] += 1
                            self.resulCateg[categoriasUsadas.index(truth[contLabels]['categ'])][categoriasUsadas.index(labels[contLabels]['categ'])] += 1  # aqui incrementa 1 para todas as palavras do texto.

                            #verifica se a palavra é fim de uma entidade
                            if(endEnt(labels,contLabels)):
                                saida = open(diretorioTrabalho+'/saidaHarem'+str(self.iteracao)+'.xml', 'a') # O 'a' significa que é o modo apende para adiconar conteúdo, texto no final do arquivo.
                                saida.write('</EM>')
                                saida.close()
#arrumar matriz conf
                            #escreve no arquivo tabela, a do Excel, o resultado do sistema e o correto
                            #if(truth[contLabels]['bilou'] == 'I'): #se o BILOU da CD for B ou for I ou  
                                # for L ou for U. truth é um vetor correspondendo a CD.   contLabels é o contador de palavras na sentença
                                #fileEx = open(dirExc,'a') #abre o arquivo do Excel
                                #fileEx.write(str(w[0][0]) + '<' + str(w[0][1]) + ',' + 'I' +'-'+  # escreve a própria palavra, BILOU 
                                #labels[contLabels]['categ'] + '>;' +str(w[0][0]) + '<' + str(w[0][1]) + ',' +  # escreve a categoria do resultado do NERP-CRF. O ponto-e-vírgula separa célula no Excel.  Escreve a própria palavra...
                                #truth[contLabels]['bilou'] +'-' + truth[contLabels]['categ'] + '>\n')  # escreve o BILOU e a categoria do CD.
                                #fileEx.close()
                            contLabels = contLabels + 1 # conta as palavras da sentença.
    
    
                        #incrementa o contdor de itens BILOU
                        self.contBilou += contLabels # contando o número de palavras pela variável contBilou, consta-se o número de BILOU's.  Self é quando está se referenciando um atributo da classe atual, aquela que se está trabalhando.
                
                        #quebra de linha a cada sentença no arquivo .xml
                        saida = open(diretorioTrabalho+'/saidaHarem'+str(self.iteracao)+'.xml', 'a')
                        saida.write('\n')  # '\n' significa nova linha.
                        saida.close()
                #encerra o texto no .xml, ou seja, a cada texto da CD é escrito o simbolo abaixo.
                saida = open(diretorioTrabalho+'/saidaHarem'+str(self.iteracao)+'.xml', 'a')
                saida.write('</DOC>\n')  # a cada texto da CD é escrito   </DOC>\n'
                saida.close()
            else:  
                continue  # vai para o próximo texto, se o texto que estava sendo analisado não tiver nada no seu conteúdo. Aí será feita todo o laço anterior, ou seja, será feita toda a execução de cima.
        #print str(bb)+'\t'+str(ii)+'\t'+str(ll)+'\t'+str(uu) 
    #retorna os resultados obtidos pela função run. 
    def results(self):  # A função run treina, testa o CRF, gera os arquivos de saída, a tabela de confusão e conta o BILOU.
        return self.result,self.resulCateg,self.resulCategEN,self.contBilou  # A função results pega os resultados da função run e devolver para quem a chamou, ou seja,   ........................
        
        
###################################################fim da classe de thread
        
#retorna lista no formato ((palava,POStagger),BILOU)
def processaTags(trainingTweets):
    expressao1 = re.compile(r'<EM.*', re.S)#expressão para encontrar o inicio da marcação de EN
    expressao2 = re.compile(r'</EM.*?>', re.S)#expressão para encontrar o fim de uma marcação de EN
    expressao3 = re.compile(r'CATEG="(.*?)"', re.S)#expressão para encontrar a categoria marcada na EN
    
    #inicialização de variaveis
    labelled = list()#labelled sera o vetor de resultado
    modo = 'O'#modo é uma variavel auxiliar para identificar valores BILOU das palavras
    categ = 'OUT'#categ é a categoria de cada palavra
    for sentenca in trainingTweets:#itera por sentenças
        if sentenca == "":#se a sentença for vazia, pula ela
            continue
        t = list()#inicializa o vetor de palavras da sentença   
        words = sentenca.split()#divide as palavras por espaços, pois não foi passado parametros, por meio da função split. Ex.: ['<EM', 'CATEG="PESSOA">', 'Daniela<N>', '</EM>']
        for i in range(len(words)):#itera por palavras, nesse caso o i percorre os indices do vetor, ou seja, vai do zero até len(words) que é o tamanho do vetor.
            word = words[i]#word é a palavra atual, ou seja, a palavra recebe a palavra atual, para inicializar a variavel word com a palavra atual.

            if i < len(words)-1:#verficia se há proxima palavra. Se a posição i da palavra for menor que o tamanho da sentença -1, significa que existe uma palavra depois da palavra atual.
                if len(expressao2.findall(words[i + 1])) > 0:#se a proxima palavra for a marcação de fim de EN
                    if modo == 'B':#se modo era B, vira U
                        modo = 'U'
                    elif modo == 'I':#se era I vira L
                        modo = 'L'
            if len(expressao1.findall(word)) > 0:#se encontrou a marcação de começo de EN com uma tamanho do resultado da pesquisa da expressão maior que zero.
                modo = 'B'
                continue
            elif len(expressao2.findall(word)) > 0:#se for a marcação de fim de EN
                modo = 'O'
                categ = 'OUT'
                continue
            categorias = expressao3.findall(word)#recolhe todas as categorias caso estejam na palavra atual; Ex.: categorias = ['PESSOA']
            if len(categorias) > 0:
                categ = categorias[0].split('|')[0]#escolhe somente a primeira categoria das opções
                continue
            if(not '<' in word):#adiciona somente palavra que possuirem marcação POS, 'palavra<POS>'
                continue

            if(categ not in categoriasUsadas and modo != 'O'):#não marca qualquer EN que não esteja classificada de acordo com as categorias escolhidas
                categ = 'OUT'
                modo = 'O'

            t.append(((word.split('<')[0], word.split('<')[1][:-1]), (modo+'-'+categ)))#adiciona a palavra, seu POS, BILOU e categoria ao vetor da sentença
            
            if modo == 'B':#se a ultima palavra for B a proxima sera I
                modo = 'I'
        labelled.append(t)#adiciona a sentença à lista de saida
	saida = open(diretorioTrabalho+'/vetor.txt','a')#abre o arquivo .txt que é o vetor no arquivo
	saida.write(str(labelled)+'\n')
	saida.close()
    return labelled#retorna o vetor de sentenças formatadas

#define a categoria da EN dependendo das regras estabelecidas para marcação de EN
def defineCateg(bilou, pos):
    
    if(classificarTodasEN):#utiliza apenas a categoria da primeira palavra para toda a EN.   classificarTodasEN é um boolean. Se ele for true retorna a linha de baixo.
	   return bilou[pos]['categ']  # 'categ' é uma categoria da uma posição pos. Se passar true para a execução do programa no paramentro classificar todas as EN retorna a categoria da primeira palavra da EN. Se for false vai para a linha, o laço de baixo.

    #verifica se toda a EN composta ou não recebeu a mesma categoria. #verifica se a categoria que foi marcada é a mesma em toda a estrutura BILOU.
    aux = bilou[pos]['categ']  
    cont = 1
    while(pos+cont < len(bilou)-1 and bilou[pos+cont]['bilou'] != 'O'):  #.......................
        if(bilou[pos+cont]['categ'] != aux): # então verifica-se que a categoria é diferente de aux.
            return 'OUT'   # é EN, mas a EN foi classificada erradamente. 
        cont += 1
    return bilou[pos]['categ'] # retorna a categoria dada a primeira palavra da EN composta para todas as outras palavras que formam essa EN, após verificar que todas as categorias são iguais.




#verifica no vetor bilou se a posição pos é inicio de uma EN bem formada
def iniEnt(bilou, pos):  #pos é a posição da palavra na sentença e bilou é o vetor de sentença no formato: [{'bilou':'B','categ':'PESSOA'},{'bilou':'I','categ':'PESSOA'}...]
    aux = True # variavel auxiliar para a logica diz que ela é verdadeira inicialmente.
    if(bilou[pos]['bilou'] == 'O'):#se for O de Out, com certeza não é inicio de entidade.  ['bilou'] é um índice que pode ser conforme o valor de pos B ou I ou L ou O ou U.   == 'O' significa que está comparando com O.
        return False  # retorna false.
    else:#caso não seja O
        if(bilou[pos]['bilou'] == 'B' and pos+1 < len(bilou)):#caso seja B e não seja a ultima palavra, procura pelo restante do formato necessário.  pos+1 < len(bilou) significa a pos+1 for menor que o tamanho do vetor de bilou, ou seja, verificar se tem uma próxima palavra após esta que está sendo analisada.
            aux2 = pos+1 # aux2 inicia no indice da palavra posterior, a fim de percorrer a sentença depois da palavra que está sendo analisada em diante. Porque pode ter vários Inside ou nenhum depois de um B.
            while(bilou[aux2]['bilou'] != 'L'):#enquanto não chegar a um L, o formato não foi cumprido
                if(bilou[aux2]['bilou'] != 'I'):#se encontrar alguma marcação diferente de I, encerra o laço e retorna não válido
                    aux = False
                    break
                aux2 += 1#incrementa o indice para a proxima palavra
                if(aux2 > len(bilou)-1):#se chegou ao fim da sentença sem o L, retorna não válido
                    aux = False
                    break
            return aux#retorna o que foi definido
        else:
            if(bilou[pos]['bilou'] == 'U'):#se for U, com certeza é o início de uma EN
                return True

#verifica no vertor bilou se a posição pos é fim de uma EN bem formada, ou seja, verificar se o CRF marcou corretamente o BILOU da EN, constatando que é fim de EN.
def endEnt(bilou, pos):
    aux = True#variavel auxiliar para a logica
    if(bilou[pos]['bilou'] == 'O'):#se for O não é fim de EN
        return False
    else:
        if(bilou[pos]['bilou'] == 'L' and pos > 0):#se for L e não for a primeira palvra, é verificado o resto do padrão.   pos > 0 significa que existe uma outra palavra antes dessa que está sendo analisada que está sendo comparada com L. Aí entra no if.
            aux2 = pos-1#aux2 inicia com o indice da palvra anterior
            while(bilou[aux2]['bilou'] != 'B'):#enquanto não encontrar o B, a condição não é satisfeita. Como foi constatado anteriormente que ocorreu uma palavra que recebeu L, verifica-se agora se a palavra anterior a que recebeu L é B. Se não for B vai para a linha de código abaixo e verifica se existe uma palavra que recebeu I.
                if(bilou[aux2]['bilou'] != 'I'):#ao encontrar algo diferente de I antes do B, não é fim de EN
                    aux = False
                    break
                aux2 -= 1#aux2 recebe o indice da palavra anterior, vai decrementando.
                if(aux2 < 0):#se não há mais para onde ir antes de encontrar o B, a EN é inválida
                    aux = False
                    break
            return aux#retorna o que foi decidido
        else:
            if(bilou[pos]['bilou'] == 'U'):#se for U, com certeza é fim de EN
                return True

#soma duas matrizes de mesmo tamanho a fim de somar os resultados parciais para gerar o resultado final das tabelas de confusão.
def soma(A, B):
    if len(A) != len(B):#se o tamanho da matriz A for diferente de B, não há soma
        raise ValueError
    for i in range(len(A)):#percorre todos os elementos das duas matrizes e os soma
        for j in range(len(A[i])):
            A[i][j] += B[i][j]
    return A#retorna A como resultado da soma das matrizes

#carrega todos os textos dourados em uma lista no formato
#[(('nomeTexto.txt',[(palavra,POSTag)]]. [(palavra,POSTag)] é o vetor de senteças.
def carregaTextos(pasta): #função chamada carregaTextos
    
    #lista com o nome de todos os arquivos do diretorio
    arquivos = os.listdir(os.path.expanduser(pasta))
    entradas = []
    for a in arquivos: #a é uma string, que é o nome do arquivo, a qual o "a" percorre item por item da lista de arquivos.
        print a#,'****************************************************'
        aux = open(pasta+'/' + a).readlines() #tem-se uma lista com todas as linhas do arquivo para posteriormente analisá-lo setença por sentença.
        while [] in aux: #enquanto o vetor de sentenças tiver alguma posição vazia
            aux.remove([])    #remove as linhas em branco.
        entradas.append((a,processaTags(aux))) # no vetor entradas é adicionado um conjunto de vetores que representam um texto.
    return entradas


#chamado em caso de erro na verificação dos parâmetros de entrada
def erroParametro():
    print"""
PARAMETROS DE ENTRADA:
DIRETORIO TREINO - diretorio contendo os arquivos .txt para treino
DIRETORIO TESTE - diretorio contendo os arquivos .txt para teste (em caso de cross validation deve ser o mesmo que o de treino)
DIRETORIO DE TRABALHO - diretorio onde ficarão salvas as saídas do sistema
DIRETORIO DO MALLET - diretorio apontando para a biblioteca MALLET
CLASSIFICAR TODAS AS EN - se deseja que todas as EN tenham uma classificação (true ou false)
CROSS VALIDATION - se deseja utilizar a técnica de cross validation (true ou false)
DIREOTORIO DO MODELO - diretorio apontando para o modelo utilizado, caso o arquivo não exista será criado um novo, caso exista será utilizado o que já está salvo
QUANTIDADE DE FOLDS - quantidade de folds da técnica de cross validation (número inteiro)
CATEGORIAS A CLASSIFICAR... - todas as categorias que queira que o sistema reconheça separadas por espaços (não preencher para utilizar todas)

USO:
<interpretador_python_alternativo> ./NERcrf.py DIRETORIO_TREINO DIRETORIO_TESTE DIRETORIO_DE_TRABALHO DIRETORIO_MALLET CLASSIFICAR_TODAS_AS_EN CROSS_VALIDATION BILOU_BIO QUANTIDADE_DE_FOLDS <CATEGORIAS...>
<opcional>
    """
    exit()


#PARAMETROS DE ENTRADA:
#DIRETORIO TREINO
#DIRETORIO TESTE
#DIRETORIO DE TRABALHO
#DIRETORIO DO MALLET
#CLASSIFICAR TODAS AS EN
#CROSS VALIDATION
#DIRETORIO DO MODELO
#QUANTIDADE DE FOLDS
#CATEGORIAS A CLASSIFICAR...

##############################################################################################
#VERIFICAÇÃO DOS PARAMETROS DE ENTRADA
##############################################################################################

if(len(sys.argv) < 8): # se o tamanho da lista de parãmetros que pode ser qualquer coisa, for menor que 8, neste caso, dá erro de parametro.
    erroParametro()

for param in sys.argv[1:3] : #limitando os diretórios para verificar as existencias dos diretórios de entrada. Laço entre o parametro 1 e 2.
    print 'confirmando diretorio',param #informando ou mostrando na tela ao usuario que esta verificando a existencia do diretorio.
    if os.path.exists(param): #verificando a existencia do diretorio.
        print 'OK'
    else:
        print 'não existe!'
        erroParametro()
print 'confirmando diretorio do MALLET',(sys.argv[4]+'/bin/mallethon')
if os.path.exists(sys.argv[4]):
    print 'OK'
else:
    print 'não existe!'
    erroParametro()
    
if(sys.argv[5] != 'true' and sys.argv[5] != 'false'): #parametro 5 é CLASSIFICAR TODAS AS EN.
    print 'valor para classificar todas as EN deve ser true ou false'
    erroParametro()

if(sys.argv[6] != 'true' and sys.argv[6] != 'false'): #parametro 6 é CROSS VALIDATION
    print 'valor para cross validation deve ser true ou false'
    erroParametro()

diretorioModelo = re.findall('^.*/', sys.argv[7])[0]#diretorioModelo recebe apenas o diretorio onde se encontra o mdelo especificado
print 'confirmando diretorio', diretorioModelo#informando ou mostrando na tela ao usuario que esta verificando a existencia do diretorio.
if os.path.exists(diretorioModelo): #verificando a existencia do diretorio.
    print 'OK'
else:
    print 'não existe!'
    erroParametro()

try:
    valor = int(sys.argv[8])#tenta converter o parametro 8 para um inteiro - parametro 8 é a quantidade de folds
except ValueError:
    print  'Quantidade de folds deve ser um numero inteiro'
    erroParametro()


diretorioTreino = sys.argv[1] #salva o parametro do diretorio de treino na variavel diretorio treino.
diretorioTeste = sys.argv[2]# "     "    "              "     de teste   "   "         " teste.
now = time.localtime()#instanciou, criou o objeto now para indicar o tempo que começou a executar o programa.
displaytime = time.strftime("%x %X",now) #converte o objeto enviado para uma data legivel.
diretorioTrabalho = sys.argv[3]+'_'+str(displaytime.replace('/','-'))#salva o diretorio de trabalho com a data e hora atual
diretorioMallet = sys.argv[4]
classificarTodasEN = sys.argv[5] == 'true' # o objeto classificarTodasEN recebe a comparação  do parametro com a string true. 
crossValidation = sys.argv[6] == 'true'
diretorioModelo = sys.argv[7]
qtdFolds = int(sys.argv[8])

if(crossValidation and diretorioTreino != diretorioTeste):#se for cross validation, os diretorios de teste e treino devem ser diferentes
    print 'não há cross-validation se os diretorios de treino e teste forem diferentes!'
    exit()

mkdir(diretorioTrabalho)#cria o diretorio de trabalho
mkdir(diretorioTrabalho+"/marcados")#cria o subdiretorio marcados dentro do diretorio de trabalho, que contém arquivos com POS, BILOU e as palavras.

if(crossValidation):#cria um diretorio para cada fold em caso de cross validation
    for i in range(qtdFolds):  # o for do Python percorre uma lista.  Range é uma função do Pytho que recebe um nr e cria uma lista de 0 até o nr dado.
    	dir = diretorioTrabalho+'/marcados/iteracao '+str(i+1)
        print 'criando diretorio', dir
        mkdir(dir)
        print 'OK'

categoriasUsadas = []# inicializa-se um vetor que é uma lista para conter todas as categorias inseridas pelo usuário.
if(len(sys.argv) >= 10):#verifica se foram passadas categorias por parametros
    for param in sys.argv[9:]:#percorre as categorias passadas por parametros
	   categoriasUsadas.append(param)#adiciona as categorias à lista
else:
##    categoriasUsadas = ['EON','ERA','PERIODO','EPOCA','IDADE','TERRESTREouFLUVIALouLACUSTRE','BENTONICO','PLANCTONICO','magmaticas','sedimentares','metamorficas']
    categoriasUsadas = ['PESSOA','ACONTECIMENTO','LOCAL','OBRA','ORGANIZACAO','TEMPO','COISA','ABSTRACCAO','VALOR','OUTRO']#utiliza todas as categorias da CD em caso de não haver passado por parametros
    
print 'utilizando as categorias:'
for c in categoriasUsadas:#mostra as categorias que serão utilizadas para o usuario
    print c,  #insere todas as categorias numa unica linha.
print ''
categoriasUsadas.append('OUT')# Adiciona a categoria OUT inserida quando a palavra for classificada como Outside do BILOU, que é sempre utilizada internamente

##############################################################################################
#INICIALIZAÇÃO DE DADOS
##############################################################################################

#inicialização da matriz de confusão
resultado = [[0, 0], [0, 0]]#matriz de confusão do BILOU
resulCateg = []#matriz de confusão das categorias a nível de palavra
resulCategEN = []#matriz de confusão das categorias a nível de EN

for y in range(len(categoriasUsadas)):#forma as matrizes de acordo com os parametros de entrada. Para y percorrendo de zero até o tamanho da lista de categorias usadas
    resulCateg.append([0 for b in range(len(categoriasUsadas))])#adiciona linhas e colunas zeradas de acordo com a quantidade de categorias escolhidas a nível de palavras, inicialmente com zeros.
    resulCategEN.append([0 for b in range(len(categoriasUsadas))]) # Adiciona uma linha na matriz de confusão a nível de EN, inicialmente com zeros na matriz de confusão.

tabelaConfusao = diretorioTrabalho+'/result.ods'# string tabelaConfusao apontando para o arquivo que serão salvas as tabelas de confusão.

#limpa se tiver um resultado anterior mais antigo no mesmo diretório e incializa o arquivo de saida no formato do Segundo HAREM para poder processar no SAHARA. Significa que esse laço vai criar um arquivo novo.
saida = open(diretorioTrabalho+'/saidaHarem.xml', 'w') # diretorioTrabalho é o nome do diretório onde serão salvos os arquivos processados.
saida.write('<?xml version="1.0" encoding="UTF-8"?>\n<!DOCTYPE colHAREM>\n<colHAREM versao="NERP_CRF '+time.strftime("%d %b %Y",now)+'">\n') # escreve no arquivo o que está entre parenteses.
saida.close() #fecha a saida.

#aviza ao NLTK onde se encontra a biblioteca MALLET
configMallet(diretorioMallet) # a função configMallet aponta para o NLTK onde se encontra o MALLET.

threads = list()#inicializa a lista de threads que serão executadas no processamento paralelo.

teste = []#teste irá conter os textos de teste

#variável para contar quantos itens BILOU foram identificados na execução do programa
contBilou = 0

##############################################################################################
#CARREGAMENTO DE ARQUIVOS
##############################################################################################

#carrega os textos dourados
treino = carregaTextos(diretorioTreino) #treino é a lista dos texots de treino. A função carregaTextos transforma todos os textos em vetores.

if(not crossValidation):#carrega os textos de teste somente se não foi requisitada cross-validation, ou seja, se não tiver cross-validation
    teste = carregaTextos(diretorioTeste)

#número de textos do diretorio
n = len(treino)
print n, 'textos para treino'
if(not crossValidation):
    print len(teste), 'textos para teste'

#para não utilizar cross-validation simula-se uma cross-validation com uma iteração. Usado para o Teste 3.
if(not crossValidation):
    nIteracoes = 1
else:
    nIteracoes = qtdFolds


##############################################################################################
#EXECUÇÃO DO CROSS VALIDATION
##############################################################################################

#gera cinco intervalos distintos para teste e treino a cada iteração
for i in range(nIteracoes):#laço sobre as iteracoes
    print (i+1), 'º Iteração' # Mostra a iteração que está sendo executada.
    
    saida = open(diretorioTrabalho+'/saidaHarem'+str(i+1)+'.xml', 'w')#cria um arquivo .xml em cada iteração para depois juntar todos
    saida.write('')#inicializa com ele vazio
    saida.close() # saida é um objeto que representa um arquivo.
    
    trainset = []#conjunto de treino
    testset = []#conjunto de teste
    
    if(crossValidation):#atua de acordo com o cross validation
        limTest = ((i * n * 1/nIteracoes), (i + 1) * n * 1/nIteracoes) #limites do conjunto de teste. (i é o fold atual, n é o nr de textos no diretorio que foi passado.) Então (i * n * 1/nIteracoes) é o limite inferior do intervalo i  e  (i + 1) * n * 1/nIteracoes) é limite superior do intervalo i, pois queremos separar o que é treino e o que é teste.
        testset = treino[limTest[0]:limTest[1]] #o conjunto de teste recebe a sua parte correspondete do corpus. Os dois pontos é o intervalo de uma lista. limTest[0] é o limite inferior de teste e limTest[1] é o limite superior de teste.

        #definindo os limites do conjunto de treino
        if(limTest[0] == 0):# se a parcela de teste for do inicio ao meio do corpus
            trainset = treino[limTest[1]:] # logo o conjunto de treino será do meio até o final do corpus.
        elif(limTest[1] >= n): #se a parcela de teste for do meio ao fim do corpus
            trainset = treino[:limTest[0]] # a parcela de treino será do meio até o início do corpus.
        else:#se a parcela de teste for no meio do corpus
            trainset = treino[:limTest[0]] + teste[limTest[1]:] # A parcela de treino do corpus será do início do corpus até o meio e a outra parcela de teste será do meio do corpus até o final dele.


        #MOSTRA OS INTERVALOS DE CADA ITERAÇÃO AO USUÁRIO
        print 'Teste', '[' , limTest[0] , ':' , limTest[1] , ']'
        print 'Treino',    
        if(limTest[0] == 0):
            print '[',limTest[1], ': ]'
        elif(limTest[1] >= n):
            print '[ :',limTest[0], ']'
        else:
            print '[ :',limTest[0], '] [',limTest[1], ': ]'


        threads.insert(i,Th(trainset,testset,i+1))#lança uma thread para cada fold

    else:#se não for cross validation
        threads.insert(i,Th(treino,teste,i+1))#lança diretamente o conjunto de treino e teste selecionado pelo usuário
    threads[i].start() # inicia a thread lançada. Aqui a função run de cada thread será executada. O start inicia a execução da função. Quando todas as threads forem executadas, usa-se a função result para se ver todos os resultados.


#espera para que todas as threads concluam
for i in range(nIteracoes):
    threads[i].join()# A função 'join' irá esperar pela thread threads[i] encerrar a sua execução. O threads[i].join() espera toda a execução de uma fold terminar. 
    
#une os restultados de todas as threads
for i in range(nIteracoes):    # para i recebendo 0 até o número de folds selecionadas
    resultadoAux,resulCategAux,resulCategENAux,contBilouAux = threads[i].results() # retorna os resultados obtidos de cada fold.
    #SOMA OS RESULTADOS PARCIAIS DAS MATRIZES DE CONFUSÃO E DO CONTADOR DE BILOU AOS RESULTADOS DEFINITIVOS.
    contBilou += contBilouAux
    resultado = soma(resultado, resultadoAux) # resultado é uma variável que significa que ela é a matriz do BILOU.
    resulCateg = soma(resulCateg,resulCategAux) # resulCateg é a nível de palavra.
    resulCategEN = soma(resulCategEN,resulCategENAux)  # resulCateg é a nível de EN.
    
    #copia o conteúdo da saida XML de todas as folds para um arquivo de saída XML final, pois foi sendo gerado um resultado parcial de cada fold e salvo em cinco arquivos, pois consideramos para o nosso sistema 5 folds.
    entrada = open(diretorioTrabalho+'/saidaHarem'+str(i+1)+'.xml', 'r') # 'r' é o modo somente de leitura.
    texto = entrada.read() # passa o arquivo xml da iteração para uma string chamada 'texto'.
    entrada.close() # fecha o arquivo xml temporário de cada fold.
    saida = open(diretorioTrabalho+'/saidaHarem.xml','a') # 'a' é o modo para adicionar conteúdo ao arquivo, por exemplo, o que foi acabado de ser copiado dos arquivos temporários de cada fold para formar um único arquivo com os resultados de todas as folds.
    saida.write(texto) #adiciona ou escreve os textos que estão em cinco arquivos, pois são 5 folds.
    saida.close() # fecha o arquivo xml com todas as folds.

#print contBilou, 'marcações BILOU'#informa ao usuário quantas marcações BILOU foram processadas

#encerra o XML no formato do HAREM
saida = open(diretorioTrabalho+'/saidaHarem.xml', 'a')   # abre o diretório /saidaHarem.xml
saida.write('</colHAREM>\n') #escreve a tag de final de coleção dourada conforme é apresentado na CD do HAREM.
saida.close() # fecha o arquivo saidaHarem.xml.

##############################################################################################
#TABELA DE CONFUSÃO BILOU
##############################################################################################

#cabecalho = '\tI\tO\tRec\tPrec\tF-Measure'#forma uma string de cabeçalho para a tabela de confusão. O t significa tab.
#print cabecalho #mostra na tela.

#file = open(tabelaConfusao, 'a')#abre o arquivo da tabela de confusão. 
#file.write('\n\n\n' + cabecalho + '\n')  #  escreve o cabeçalho
#file.close()

#itera sobre cada dimensão, pois pode ser linha ou coluna da tabela de confusão, percorendo de 0 até 4 do BILOUs.
for i in range(len(resultado)):  # Aqui o i vale de 0 a 4 de acordo com o BILOU.
    prec = rec = 0  # precisão e recall inicia com zero.
    #a recebe a soma de todos os itens da coluna da tabela
    a = (sum([resultado[j][i] for j in range(len(resultado))]))  # soma todos os itens da lista para obter a soma da coluna. Nesta linha de código, o valor de i é fixo até chegar no próximo laço. O j varia de 0 a 4, enquanto o i fica fixo valendo 0. Depois o i vale 1 e o j varia de 0 a 4 e assim por diante, terminando com o i valendo 4. A soma significa por exemplo, se o i vale 0, soma-se então a coluna do B. Se o i valer 1, soma-se a coluna do 1 e assim por diante. resultado é a matriz de confusão do BILOU. Aqui fixa-se a coluna e varia-se a linha.
    if a != 0:
        #calcula-se a precisão dividindo o que foi marcado certo
        #por tudo que foi marcado para cada item
        prec = float(resultado[i][i]) / a # A precisão é o que o sistema marcou corretamente dividido pela soma feita no laço anteriro. Pegam se as células 0 0, 1 1, 2 2, 3 3 e 4 4, pois a diagonal principal da matriz de confusão é a que fornece o que foi marcado corretamente pelo sistema para o BILOU. float converte o número inteiro dos resultados obtidos pelo BILOU para número com vírgula, real que são os resultados da Precisão.

    #a recebe a soma de todos os itens da linha da tabela
    a = (sum([resultado[i][j] for j in range(len(resultado))])) # É semelhante com a soma do laço anterior para a Precisão, só que agora fixa-se a linha e varia-se a coluna.
    if a != 0:
        #calcula-se o recall
        #dividindo o que foi marcado certo na posição i i, agora, dividido pela soma da linha.
        rec = float(resultado[i][i]) / a

    #calcula a F-Measure
    if(prec+rec == 0):
        fMeasure = 'div 0'
    else:
        fMeasure = (2*prec*rec)/(prec+rec)

    #forma a string da linha
    saida = str(classe(i))+ '\t'+ str(resultado[i][0])+ '\t'+ str(resultado[i][1])+ '\t'+ str(rec)+ '\t'+ str(prec) + '\t' + str(fMeasure)  # str é a função que converte qualquer coisa para string. Neste caso converte um inteiro e um float.

    #print saida#mostra a linha para o usuário
        
    #file = open(tabelaConfusao, 'a')# abre o arquivo que está na variável de nome tabela de confusão
    #file.write(saida + '\n')  #escreve a linha no arquivo da tabela de confusão e dá um \n, ou seja, nova linha.
    #file.close()   
    # o laço acima é feito para cada linha da tabela de confusão.

##############################################################################################
#TABELA DE CONFUSÃO DE CATEGORIAS A NIVEL DE PALAVRA
##############################################################################################    

cabecalho2 = 'CATEGORIAS\n'
for categ in categoriasUsadas:
    cabecalho2+='\t'+categ
cabecalho2+='\tRec\tPrec\tF-Measure'

#print cabecalho2

#file = open(tabelaConfusao, 'a')
#file.write('\n\n\n' + cabecalho2 + '\n')
#file.close()

#itera sobre cada linha da tabela de confusão
for i in range(len(resulCateg)):
    prec = rec = 0
    #a recebe a soma de todos os itens da coluna da tabela
    a = (sum([resulCateg[j][i] for j in range(len(resulCateg))]))
    if a != 0:
        #calcula-se a precisão dividindo o que foi marcado certo
        #por tudo que foi marcado para cada item
        prec = float(resulCateg[i][i]) / a

    #a recebe a soma de todos os itens da linha da tabela
    a = (sum([resulCateg[i][j] for j in range(len(resulCateg))]))
    if a != 0:
        #calcula-se a abrangência
        #dividindo o que foi marcado certo
        rec = float(resulCateg[i][i]) / a

    #calcula a F-Measure
    if(prec+rec == 0):
        fMeasure = 'div 0'
    else:
        fMeasure = (2*prec*rec)/(prec+rec)
    
    saida = str(categoriasUsadas[i])
    for p in range(len(categoriasUsadas)):
        saida+='\t'+str(resulCateg[i][p])
    saida += '\t'+str(rec)+ '\t'+ str(prec) + '\t' + str(fMeasure)
    #print saida
        
    #file = open(tabelaConfusao, 'a')
    #file.write(saida + '\n')
    #file.close()
    
##############################################################################################
#TABELA DE CONFUSÃO DE CATEGORIAS A NIVEL DE EN
##############################################################################################

cabecalho3 = 'CATEGORIAS a nivel de EN\n'
for categ in categoriasUsadas:
    cabecalho3+='\t'+categ
cabecalho3+='\tRec\tPrec\tF-Measure'


#file = open(tabelaConfusao, 'a')
#file.write('\n\n\n' + cabecalho3 + '\n')
#file.close()
#print cabecalho3

#itera sobre cada linha da tabela de confusão
for i in range(len(resulCategEN)):
    prec = rec = 0
    #a recebe a soma de todos os itens da coluna da tabela
    a = (sum([resulCategEN[j][i] for j in range(len(resulCategEN))]))
    if a != 0:
        #calcula-se a precisão dividindo o que foi marcado certo
        #por tudo que foi marcado para cada item
        prec = float(resulCategEN[i][i]) / a

    #a recebe a soma de todos os itens da linha da tabela
    a = (sum([resulCategEN[i][j] for j in range(len(resulCategEN))]))
    if a != 0:
        #calcula-se a abrangência
        #dividindo o que foi marcado certo
        rec = float(resulCategEN[i][i]) / a

    #calcula a F-Measure
    if(prec+rec == 0):
        fMeasure = 'div 0'
    else:

        fMeasure = (2*prec*rec)/(prec+rec)

    saida = str(categoriasUsadas[i])
    for p in range(len(categoriasUsadas)):
        saida+='\t'+str(resulCategEN[i][p])
    saida += '\t'+str(rec)+ '\t'+ str(prec) + '\t' + str(fMeasure)

    #print saida

    #file = open(tabelaConfusao, 'a')
    #file.write(saida + '\n')
    #file.close()

print "Marcação Finalizada."