
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.logging.Level;
import java.util.logging.Logger;

//Modificada para ler em Latin-1 - encodingLeitura e escrever em UTF-8 - encodingEscrita

public class Arquivo {

    private String caminho_arquivo;
    private BufferedReader arquivoLeitura;
    private BufferedWriter arquivoEscrita;
    private String encodingLeitura = "utf8";
    private String encodingEscrita = "utf8";

    public Arquivo(String caminho) {
        this.caminho_arquivo = caminho;
    }

    public String getCaminho_arquivo() {
        return caminho_arquivo;
    }

    public void setCaminho_arquivo(String caminhoArquivo) {
        caminho_arquivo = caminhoArquivo;
    }

    public BufferedReader getArquivoLeitura() {
        return arquivoLeitura;
    }

    public void setArquivoLeitura(BufferedReader arquivo) {
        this.arquivoLeitura = arquivo;
    }

    public BufferedWriter getArquivoEscrita() {
        return arquivoEscrita;
    }

    public void setArquivoEscrita(BufferedWriter arquivoEscrita) {
        this.arquivoEscrita = arquivoEscrita;
    }

    public void abrirArquivoLeitura() {
        try {
            this.setArquivoLeitura(new BufferedReader(new InputStreamReader(new FileInputStream(this.getCaminho_arquivo()), encodingLeitura)));
            //this.setArquivoLeitura(new BufferedReader(new FileReader(this.getCaminho_arquivo())));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void abrirArquivoEscrita() {
        try {
            this.setArquivoEscrita(new BufferedWriter(new OutputStreamWriter(new FileOutputStream(this.getCaminho_arquivo()), encodingEscrita)));
            //this.setArquivoEscrita(new BufferedWriter(new FileWriter(this.getCaminho_arquivo())));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String lerArquivo() {
        String conteudoArquivo = "";
        BufferedReader arquivo = this.getArquivoLeitura();

        try {

            while (arquivo.ready()) {
                conteudoArquivo += arquivo.readLine();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return (conteudoArquivo);
    }

    public void escreverLinha(String linha) {
        BufferedWriter arquivo = this.getArquivoEscrita();    
        try {
            arquivo.write(linha);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void quebraLinha(){// é como se inserisse um enter, indo para outra linha.
        BufferedWriter arquivo = this.getArquivoEscrita();
        try {
            arquivo.newLine();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public void fecharArquivoLeitura() {
        try {
            this.getArquivoLeitura().close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void fecharArquivoEscrita() {
        try {
            this.getArquivoEscrita().close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
