
import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
public class Main {

    public static void main(String[] args) {
    	int cnt = 0;//total de entidades processadas na execução
        int sentencasTot = 0;//total de sentenças processadas na execução
    	
        String caminho_modelos = "";//camnho do diretorio dos modelos treinados
        String caminho_arquivos = "";//caminho do diretorio dos arquivo para serem marcados


        JFileChooser chooser_modelos = new JFileChooser();//inicializa objetos de seleção de diretorio
        JFileChooser chooser_arquivos = new JFileChooser();
        
        chooser_modelos.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);//seleciona apenas diretorios
        chooser_arquivos.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        
        JOptionPane.showMessageDialog(null, "Selecione o modelo treinado (Tagger/Arquivos-bin)", "Modelo", JOptionPane.PLAIN_MESSAGE);//abre a janela de seleção de diretorio
        if (chooser_modelos.showOpenDialog(chooser_modelos) != JFileChooser.APPROVE_OPTION) {//seleção cancelada
            JOptionPane.showMessageDialog(null, "O diretório de modelos deve ser informado!");
            System.exit(0);
        }

        JOptionPane.showMessageDialog(null, "Selecione o diretorio contendo os arquivos a serem marcados", "Textos", JOptionPane.PLAIN_MESSAGE);
        if (chooser_arquivos.showOpenDialog(chooser_arquivos) != JFileChooser.APPROVE_OPTION) {
            JOptionPane.showMessageDialog(null, "O diretório de modelos deve ser informado!");
            System.exit(0);
        }

        caminho_modelos = chooser_modelos.getSelectedFile().toString();//caminho_modelos contem o diretorio com os modelos treinados
        caminho_arquivos = chooser_arquivos.getSelectedFile().toString();//caminho_arquivos contem o diretorio com os arquivos a serem marcados
        caminho_arquivos = caminho_arquivos.replace('\\','/');//inverte as barras (Windows)

        System.out.println("Caminho Arquivos: " + caminho_arquivos);

        String sent = caminho_modelos + "/pt-sent.bin";//sent contem o caminho para o modelo do sentenciador
        String tok = caminho_modelos + "/pt-token.bin";//tok contem o caminho para o modelo do tokenizador
        String pos = caminho_modelos + "/pt-pos-maxent.bin";//pos contem o caminho para o modelo do POS tagger

	System.out.println("Modelo do sentenciador:", sent);
	System.out.println("Modelo do tokenizador:", tok);
	System.out.println("Modelo do POS tagger:", pos);

        //todas as EN do texto
        ArrayList<EntidadeMencionada> EMs = new ArrayList<EntidadeMencionada>();

        Tagger tagger = new Tagger(sent, tok, pos);//instancia o objeto Tagger

        File dir = new File(caminho_arquivos);//instancia um objeto File com o diretorio de entrada
        String[] arquivos = dir.list();//arquivos contem todos os arquivos dentro do diretorio de entrada
        
        //cria automaticamente o diretório /tagged, onde serão salvos os textos marcados
        File tagged = new File(caminho_arquivos+"/tagged");  
        if (tagged.mkdir()) {  
            System.out.println("Diretorio /tagged criado com sucesso");  
        } else {  
            System.out.println("Erro ao criar diretorio /tagged!");
        }

        for (int i = 0; i < arquivos.length; i++) {//laço sobre os arquivos válidos.
        	//seleciona apenas arquivos .txt, não temporários e não ocultos
            if (!arquivos[i].endsWith("~") && arquivos[i].endsWith(".txt") && !arquivos[i].startsWith(".")) {//verifica se o arquivo não é temporario, termina em .txt e não é oculto
                System.out.println((i+1)+"º Arquivo: ===> " + arquivos[i]);//mostra o arquivo que sera processado.
                Arquivo arqLeitura = new Arquivo(caminho_arquivos + "/" + arquivos[i]);//instancia Arquivo com o caminho de leitura
                Arquivo arqEscrita = new Arquivo(caminho_arquivos + "/tagged/" + arquivos[i]);//instancia Arquivo com o caminho de escrita
                arqLeitura.abrirArquivoLeitura();
                arqEscrita.abrirArquivoEscrita();

                System.out.println("Lendo conteúdo do arquivo...");
                String conteudo = arqLeitura.lerArquivo();//conteudo contem o conteudo de cada texto, ou seja, pega todo o arquivo lido e guarda numa string.
		conteudo = conteudo.replace(".\n", ". \n");
                System.out.println("Iniciando o processo de tagging...");
                Sentenca[] sents = tagger.tag(conteudo, EMs);//Aqui é chamada a função tag do arquivo de nome Tagger.java. Essa realiza o tagger do arquivo de entrada, ou seja, divide o texto em sentença, divide o texto em palavras e faz a marcação do POS.
                cnt += EMs.size();//incrementa o contador de entidades
                System.out.println("Tagging pronto...");

                System.out.println("Iniciando a escrita em arquivo..." + "(" + caminho_arquivos + "/tagged/" + arquivos[i] + ")");
                
                int aux = 0;//contador de ENs
                int aux2 = 0;//contador de palavras
                boolean pula = false;//controle para evitar tokens de ; que sempre seguem os &amp. O pula quando for true pula para proxima linha.Porque aparece o simbolo &amp que atrapalha o processo de POS. 
                for (int cont = 0; cont < sents.length; cont++) {//laço sobre as sentenças encontradas
                    Sentenca s = sents[cont];//s é a sentença atual

                    for (int cont2 = 0; cont2 < s.getTokens().size(); cont2++) {//laço sobre as palavras da sentença
                        if(pula){
                            pula = false;
                            continue;
                        }
                        String palavra;//palavra atual no formato palavra<POS>
                        if(s.getToken(cont2).getSimbolo().equals("&amp")){//tratamento especial para o &amp
                        	palavra = s.getToken(cont2).getSimbolo() + s.getToken(cont2+1).getSimbolo() + "<conj-c> ";
                            pula = true;
                        } else {
                        	palavra = s.getToken(cont2).getSimbolo() + "<" + s.getToken(cont2).getPOStag() + "> "; //palavra = "palavra<POS>"
                        }

                        if(EMs.size() > 0)//se foram encontradas ENs
	                        if (EMs.get(aux).getInicio() == aux2) {//se o inicio da entidade for na posição atual.  aux é o contador de EN. aux2 é contador da palavra.
	                        	//escreve no arquivo de saida a marcação de inicio EN de acordo com a CD
	                            arqEscrita.escreverLinha("<EM " + EMs.get(aux).getId() + " " +
	    	                        						EMs.get(aux).getCateg() + " " +
	                            							EMs.get(aux).getTipo() + " " +
	                            							EMs.get(aux).getCorel() + " " +
	                            							EMs.get(aux).getTiporel() + "> ");
	                        }
                        arqEscrita.escreverLinha(palavra);//escreve a palavra atual no arquivo de saída.
                        if(EMs.size() > 0)// Testa de novo se foram encontradas ENs para não ter erro de implementação.
	                        if (EMs.get(aux).getFim() == aux2) {//  se o fim da entidade estiver na posição atual. Está comparando números pois são posições.
	                            arqEscrita.escreverLinha("</EM> ");//escreve a marcação de fim de EN de acordo com a CD
	                            if (aux < EMs.size()-1) {//incrementa o contador de entidades para ver se não está no fim da lista ou numa posição que não existe.
	                                aux++;
	                            }
	
	                        }

                        if(pula)//incrementa o contador de palavras uma vez a mais se pula for true
                            aux2++;
                        aux2++;

                    }
                    arqEscrita.quebraLinha();//escreve a marcação de fim de linha \n no arquivo para dizer que terminou a sentença.
                }
                System.out.println(arquivos[i] + " pronto. =====> Next...");
                arqEscrita.fecharArquivoEscrita(); //fecha o arquivo de escrita.

                EMs = new ArrayList<EntidadeMencionada>(); //inicializa novamente o vetor EMs para que no próximo arquivo esteja vazio o vetor.

                System.out.println(sents.length + " sentenças."); //mostra quantas sentenças o programa processou no texto atual.
                sentencasTot += sents.length; // incrementa o número de sentenças total processadas.

            }
        }
        System.out.println(sentencasTot + " sentenças processadas.");
        System.out.println(cnt + " entidades detectadas.");
        System.out.println("Feito.");

    }
}
