import java.util.ArrayList;


public class Sentenca {

	ArrayList<Token> tokens;
	
	/**
	 * Construtor da classe. Classe que armazena um conjunto de palavras e mais o POS de cada palavra. 
	 */
	public Sentenca(){
		tokens = new ArrayList<Token>();
	}

	public ArrayList<Token> getTokens() {
		return tokens;
	}

	public void setTokens(ArrayList<Token> tokens) {
		this.tokens = tokens;
	}
	
	/**
	 * Adiciona um novo token a sentenca.
	 * @param token Token a ser adicionado.
	 */
	public void addToken(Token token){
		this.getTokens().add(token);
	}
	
	/**
	 * Retorna o token indicado pelo parametro.
	 * @param indice Indice do token a ser retornado.
	 * @return Token.
	 */
	public Token getToken(int indice){
		return(this.getTokens().get(indice));
	}
}
