import opennlp.tools.util.Span;


/**
 * Classe que armazena as informacoes relacionadas aos simbolos componentes de uma sentenca. Classe que guarda a palavra e o POS dela.
 *
 */

public class Token {

	private String simbolo;
	private String POStag;
	private Span limites;
	private double probabilidade;
	
	
	/**
	 * Construtor da classe.
	 * @param simbolo Palavra.
	 * @param POStag POS tag atribuido.
	 * @param limites Indica as posicoes inicial e final do simbolo em questão na sentenca selecionada
	 * @param probabilidade Probabilidade do rotulo atribuido.
	 */
	public Token(String simbolo, String POSTag, Span limites, double probabilidade) {
		this.simbolo = simbolo;
		this.POStag = POSTag;
		this.limites = limites;
		this.probabilidade = probabilidade;
	}

	public Token() {
		this.simbolo = null;
		this.POStag = null;
		this.limites = null;
		this.probabilidade = 0;
	}

	public String getSimbolo() {
		return simbolo;
	}

	public String getPOStag() {
		return POStag;
	}

	public Span getLimites() {
		return limites;
	}

	public double getProbabilidade() {
		return probabilidade;
	}

	public void setSimbolo(String simbolo) {
		this.simbolo = simbolo;
	}

	public void setPOStag(String pOStag) {
		POStag = pOStag;
	}

	public void setLimites(Span limites) {
		this.limites = limites;
	}

	public void setProbabilidade(double probabilidade) {
		this.probabilidade = probabilidade;
	}
	
	
	
	
	
	
}
