#!/usr/bin/env python
# coding: utf-8
from datetime import datetime
from Tkinter import *
import Tkconstants, tkFileDialog
import os
class Window(Frame):
  
  def __init__(self,parent):
    Frame.__init__(self,parent)
    self.parent = parent
    self.inicial()
    
  def inicial(self):
    menubar = Menu(self.parent)
    self.parent.config(menu=menubar)
    button_opt = {'fill': Tkconstants.BOTH, 'padx': 20, 'pady': 20}
    fileMenu = Menu(menubar)
    fileMenu.add_command(label="Informacoes", command = self.info)
    fileMenu.add_command(label="Sair do Programa", command=self.onExit)
    menubar.add_cascade(label="Sobre", menu=fileMenu)
    self.parent.title("NERP CRF")
    self.parent.geometry("500x350+450+400")
    self.parent.configure(relief="ridge", border=10)
    #self.b1 = Button(self,font="Arial 14 bold", width = 40, height = 5,border=5, text='Instalar bibliotecas', command=self.instalacao)
    #self.b1.pack (**button_opt)
    self.b2 = Button(self,font="Arial 14 bold", width = 40, height = 5,border=5, text="Executar NERP", command=self.executar)
    self.b2.pack(**button_opt)
    self.pack()
    
  def info(info):
    info = Tk()
    info.title("INFO")
    info.geometry("300x200+470+420")
    info.msg = Label(info,font="Arial 10", text = "Informacoes sobre o NERP")
    info.msg.pack ()
        
  def onExit(self):
    self.quit()
    
  def converter(self):
    directory = tkFileDialog.askdirectory()
    directory2 = directory+"/utf8"
    d3 = directory2.replace(" ","\ ")
    print(d3)
    d2 = d3.encode('utf-8')
    listarq = os.listdir(directory)
    os.system("mkdir "+d2)
    for arquivo in listarq:
      d = directory.replace(" ","\ ")
      d1 = d.encode('utf-8')
      arq = arquivo.encode('utf-8')
      name = "iconv -f iso-8859-1 -t utf-8 "+d1+"/"+arq+" > "+d2+"/"+arq
      os.system(name)


    
  def executar(self):
    Frame.__init__(self)
    button_opt = {'fill': Tkconstants.BOTH, 'padx': 10, 'pady': 10}
    self.msg = Label(self,font="Arial 10", text="Os textos precisam estar no formato UTF-8,\n caso nao estejam, utilize o conversor")
    self.msg.pack (**button_opt)
    self.but1 = Button(self, font="Arial 12 bold", width = 8, height = 1,border=5, text = "Converter", command = self.converter)
    self.but1.pack(padx=2, pady=2)
    self.but2 = Button(self, font="Arial 14 bold", width = 30, height = 2, border = 5, text = "Etiquetar(OpenNLP)", command = self.etiquetador)
    self.but2.pack(**button_opt)
    self.but3 = Button (self,font="Arial 14 bold", width = 30, height = 2,border=5, text="Passar textos no NERP", command=self.askdirectory)
    self.but3.pack (**button_opt)
    self.pack()
    self.dir_opt = options = {}
    options['initialdir'] = 'C:\\'
    options['mustexist'] = False
    options['title'] = 'Selecione o diretorio dos textos'
    
  def etiquetador(self):
    os.system("java -jar OpenNLP/OpenNLP.jar")
    
  def instalacao(self):
    os.system("sudo su")
    os.system("sudo python NERP/bibliotecas/setuptools-0.6c11/setup.py install")
    os.system("sudo python NERP/bibliotecas/feedparser-5.1.1/setup.py install")
    os.system("sudo easy_install NLTK")
    os.system("sudo python NERP/bibliotecas/nltk-2.0b9/setup.py install")
    os.system("sudo python NERP/bibliotecas/PyYAML-3.10/setup.py install")
    os.system("sudo apt-get install python-dev")
    os.system("sudo python NERP/bibliotecas/numpy-1.6.1/setup.py install")
    os.system("sudo apt-get install libatlas-base-dev gfortran")
    os.system("sudo python NERP/bibliotecas/scipy-0.10.1/setup.py install")

  
  def askdirectory(self):
    #texts = tkFileDialog.askdirectory(**self.dir_opt)
    #corte = texts.replace(" ", "\ ")
    time = str(datetime.now())
    data = time.replace(" ","-")
    terminal = "python NERP/NERP_CRF/NERcrf.py NERP/NERP_CRF/entradas/treino/ NERP/NERP_CRF/entradas/teste/ NERP/NERP_CRF/./saida NERP/bibliotecas/Mallet/mallet-0.4 true false NERP/NERP_CRF/./"+data+" 10"
    utf8f = terminal.encode('utf-8')
    os.system(utf8f)
    
def main():
    raiz = Tk()
    app = Window(raiz)
    raiz.mainloop()


if __name__ == '__main__':
    main()    
    

